diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 9f7098a11..6257ec3c7 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,18 +1,18 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.BlockBed;
+import net.minecraft.core.block.BedBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.SpawnListEntry;
-import net.minecraft.core.entity.monster.EntityArmoredZombie;
-import net.minecraft.core.entity.monster.EntitySkeleton;
-import net.minecraft.core.entity.monster.EntitySpider;
-import net.minecraft.core.entity.monster.EntityZombie;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.enums.EnumCreatureType;
+import net.minecraft.core.entity.monster.SkeletonMob;
+import net.minecraft.core.entity.monster.ZombieArmoredMob;
+import net.minecraft.core.entity.monster.SpiderMob;
+import net.minecraft.core.entity.monster.ZombieMob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.MobCategory;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
@@ -45,9 +45,9 @@ public final class SpawnerMobs
         if(!spawnHostileMobs && !spawnPassiveMobs) { return 0; }
         eligibleChunksForSpawning.clear();
 
-        for (EntityPlayer player : world.players){
-            final int playerChunkX = MathHelper.floor_double(player.x / (double) Chunk.CHUNK_SIZE_X);
-            final int playerChunkZ = MathHelper.floor_double(player.z / (double) Chunk.CHUNK_SIZE_Z);
+        for (Player player : world.players){
+            final int playerChunkX = MathHelper.floor(player.x / (double) Chunk.CHUNK_SIZE_X);
+            final int playerChunkZ = MathHelper.floor(player.z / (double) Chunk.CHUNK_SIZE_Z);
             final byte spawnRadius = 8;
 
             for(int dx = -spawnRadius; dx <= spawnRadius; ++dx) {
@@ -69,11 +69,11 @@ public final class SpawnerMobs
         }
 
 
-        for (EnumCreatureType creatureType : EnumCreatureType.values()) {
+        for (MobCategory creatureType : MobCategory.values()) {
 
-            if (creatureType.getPeacefulCreature() && !spawnPassiveMobs) continue;
-            if (!creatureType.getPeacefulCreature() && !spawnHostileMobs) continue;
-            if (world.countEntities(creatureType.getCreatureClass()) > ((creatureType.getMaxNumberOfCreature() * eligibleChunksForSpawning.size()) / 256))
+            if (creatureType.isPeaceful() && !spawnPassiveMobs) continue;
+            if (!creatureType.isPeaceful() && !spawnHostileMobs) continue;
+            if (world.countEntities(creatureType.getBaseClass()) > ((creatureType.getMaxCreaturesPerChunk() * eligibleChunksForSpawning.size()) / 256))
                 continue;
 
             chunkLoop: for (ChunkCoordinate chunk : eligibleChunksForSpawning) {
@@ -115,7 +115,7 @@ public final class SpawnerMobs
                 final int x = pos.x;
                 final int y = pos.y;
                 final int z = pos.z;
-                if (world.isBlockNormalCube(x, y, z) || world.getBlockMaterial(x, y, z) != creatureType.getCreatureMaterial())
+                if (world.isBlockNormalCube(x, y, z) || world.getBlockMaterial(x, y, z) != creatureType.getSpawnMaterial())
                     continue;
 
                 int countSpawned = 0;
@@ -146,16 +146,16 @@ public final class SpawnerMobs
                             if (spawnDistanceSquared < 576.0F) continue;
                         }
 
-                        EntityLiving mobToSpawn;
+                        Mob mobToSpawn;
                         try {
-                            mobToSpawn = (EntityLiving) spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
+                            mobToSpawn = (Mob) spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
                         } catch (Exception e) {
                             new RuntimeException("Error spawning entity class '" + spawnListEntry.entityClass.getSimpleName() + "' class missing default constructor for World! Skipping spawn attempt!", e).printStackTrace();
                             return totalSpawned;
                         }
 
                         mobToSpawn.moveTo(dx, dy, dz, world.rand.nextFloat() * 360.0F, 0.0F);
-                        if (!mobToSpawn.getCanSpawnHere()) {
+                        if (!mobToSpawn.canSpawnHere()) {
                             continue;
                         }
 
@@ -173,9 +173,9 @@ public final class SpawnerMobs
         return totalSpawned;
     }
 
-    private static boolean canCreatureTypeSpawnAtLocation(EnumCreatureType enumcreaturetype, World world, int x, int y, int z)
+    private static boolean canCreatureTypeSpawnAtLocation(MobCategory enumcreaturetype, World world, int x, int y, int z)
     {
-        if(enumcreaturetype.getCreatureMaterial() == Material.water)
+        if(enumcreaturetype.getSpawnMaterial() == Material.water)
         {
             return world.getBlockMaterial(x, y, z).isLiquid() && !world.isBlockNormalCube(x, y + 1, z);
         } else
@@ -184,7 +184,7 @@ public final class SpawnerMobs
         }
     }
 
-	public static boolean performSleepSpawning(World world, List<EntityPlayer> list)
+	public static boolean performSleepSpawning(World world, List<Player> list)
     {
         if (!world.getGameRuleValue(GameRules.DO_NIGHTMARES))
         {
@@ -194,7 +194,7 @@ public final class SpawnerMobs
 		PathFinder pathFinder = new PathFinder(world);
 
         // For each player in the player list
-		for (EntityPlayer player : list)
+		for (Player player : list)
         {
             // Ignore conditions where monsters shouldn't spawn
 			if (!player.isPlayerSleeping())
@@ -216,9 +216,9 @@ public final class SpawnerMobs
 				while (i < 20 && !spawnedEntityForPlayer)
                 {
                     // Get a random location for the monster to spawn
-					int x = MathHelper.floor_double(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32);
-					int z = MathHelper.floor_double(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32);
-					int y = MathHelper.floor_double(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16);
+					int x = MathHelper.floor(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32);
+					int z = MathHelper.floor(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32);
+					int y = MathHelper.floor(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16);
 					y = MathHelper.clamp(y, 1, world.getHeightBlocks());
 					
 					int spawnY = y;
@@ -231,7 +231,7 @@ public final class SpawnerMobs
 
                     // Make sure we're allowed to spawn in this Y coordinate
 					while(
-                            !canCreatureTypeSpawnAtLocation(EnumCreatureType.monster, world, x, spawnY, z) &&
+                            !canCreatureTypeSpawnAtLocation(MobCategory.monster, world, x, spawnY, z) &&
                             spawnY < y + 16 &&
                             spawnY < world.getHeightBlocks()
                     )
@@ -249,10 +249,10 @@ public final class SpawnerMobs
 						float entityY = spawnY;
 						float entityZ = z + 0.5f;
 						
-						EntityLiving entity;
+						Mob entity;
 						try
                         {
-							entity = (EntityLiving) entityClasses[world.rand.nextInt(entityClasses.length)].getConstructor(World.class).newInstance(world);
+							entity = (Mob) entityClasses[world.rand.nextInt(entityClasses.length)].getConstructor(World.class).newInstance(world);
 						}
                         catch (Exception e)
                         {
@@ -261,15 +261,15 @@ public final class SpawnerMobs
 						}
 						
 						entity.moveTo(entityX, entityY, entityZ, world.rand.nextFloat() * 360.0f, 0.0f);
-						if(entity.getCanSpawnHere())
+						if(entity.canSpawnHere())
                         {
 							Path pathEntity = pathFinder.findPath(entity, player, 32.0f);
 							if(pathEntity != null && pathEntity.length > 1)
                             {
 								Node pathPoint = pathEntity.last();
-                                boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3d.createVector(player.x, player.y + 1.5f, player.z), Vec3d.createVector(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
+                                boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(player.x, player.y + 1.5f, player.z), Vec3.getTempVec3(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
 								if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
-									ChunkCoordinates pos = BlockBed.getNearestEmptyChunkCoordinates(world, MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z), 1);
+									ChunkCoordinates pos = BedBlock.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
 									if(pos == null) {
 										pos = new ChunkCoordinates(x, spawnY + 1, z);
 									}
@@ -298,7 +298,7 @@ public final class SpawnerMobs
     static 
     {
         nightSpawnEntities = new Class[] {
-            EntitySpider.class, EntityZombie.class, EntitySkeleton.class, EntityArmoredZombie.class
+            SpiderMob.class, ZombieMob.class, SkeletonMob.class, ZombieArmoredMob.class
         };
     }
 }
